---
title: Using WebGL extensions
slug: Web/API/WebGL_API/Using_Extensions
tags:
  - Advanced
  - WebGL
---
<div>{{WebGLSidebar}}</div>

<p>WebGL, like its sister APIs (OpenGL and OpenGL ES), supports extensions. A complete list of extensions is available in the <a class="external" href="http://www.khronos.org/registry/webgl/extensions/">khronos webgl extension registry</a>.</p>

<div class="note"><strong>Note:</strong> In WebGL, unlike in other GL APIs, extensions are only available if explicitly requested.</div>

<h2 id="Canonical_extension_names_vendor_prefixes_and_preferences">Canonical extension names, vendor prefixes and preferences</h2>

<p>Extensions may be supported by browser vendors before being officially ratified (but only when they are in draft stage). In that case, their name can be prefixed by the vendor prefix (<code>MOZ_</code>, <code>WEBKIT_</code>, etc.) or the extension is only available once a browser preference has been toggled.</p>

<p>If you wish to work with the bleeding edge of extensions, and want to keep working on upon ratification (assuming, of course, that the extension doesn't change in incompatible ways), that you query the canonical extension name as well as the vendor extension name. For instance:</p>

<pre class="brush:js notranslate">var ext = (
  gl.getExtension('OES_vertex_array_object') ||
  gl.getExtension('MOZ_OES_vertex_array_object') ||
  gl.getExtension('WEBKIT_OES_vertex_array_object')
);
</pre>

<p>Note that, vendor prefix have been discouraged more and more and thus most browser implement experimental extensions behind a feature flag rather than vendor prefix.</p>

<p>The feature flags are:</p>

<ul>
 <li><code>webgl.enable-draft-extensions</code> in Firefox</li>
 <li><code>chrome://flags/#enable-webgl-draft-extensions</code> in Chromium based browsers (Chrome, Opera).</li>
</ul>

<h2 id="Naming_conventions">Naming conventions</h2>

<p>WebGL extensions are prefixed with "ANGLE", "OES", "EXT" or "WEBGL". These prefixes reflect origin and intent:</p>

<ul>
 <li><code>ANGLE_</code>: Extensions that are written by the <a href="https://en.wikipedia.org/wiki/ANGLE_%28software%29">ANGLE library</a> authors.</li>
 <li><code>OES_</code> and <code>KHR_</code>: Extensions that mirror functionality from OpenGL ES (OES) or OpenGL API extensions approved by the respective architecture review boards (Khronos).</li>
 <li><code>OVR_</code>: Extensions that optimize for virtual reality.</li>
 <li><code>EXT_</code>: Extensions that mirror other OpenGL ES or OpenGL API extensions.</li>
 <li><code>WEBGL_</code>: Extensions that are WebGL-specific and intended to be compatible with multiple web browsers. It should also be used for extensions which originated with the OpenGL ES or OpenGL APIs, but whose behavior has been significantly altered.</li>
</ul>

<h2 id="Querying_available_extensions">Querying available extensions</h2>

<p>The WebGL context supports querying what extensions are available.</p>

<pre class="brush:js notranslate">var available_extensions = gl.getSupportedExtensions();</pre>

<p>The {{domxref("WebGLRenderingContext.getSupportedExtensions()")}} method returns an array of strings, one for each supported extension.</p>

<h2 id="Extension_list">Extension list</h2>

<p>The current extensions are:</p>

<p>{{page("en-US/docs/Web/API/WebGL_API", "Extensions")}}</p>

<h2 id="Enabling_an_extension">Enabling an extension</h2>

<p>Before an extension can be used it has to be enabled using {{domxref("WebGLRenderingContext.getExtension()")}}. For example:</p>

<pre class="brush:js notranslate">var float_texture_ext = gl.getExtension('OES_texture_float');</pre>

<p>The return value is <code>null</code> if the extension is not supported, or an extension object otherwise.</p>

<h2 id="Extension_objects">Extension objects</h2>

<p>If an extension defines specific symbols or functions that are not available in the core specification of WebGL, they will be available on the extension object returned by the call to <code>gl.getExtension()</code>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getSupportedExtensions()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li><a class="external external-icon" href="http://webglreport.com">webglreport.com</a></li>
 <li><a href="http://webglstats.com">webglstats.com</a></li>
</ul>
